unit SGForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, SGClass, StdCtrls, ComCtrls, ExtCtrls, WaveFmt, ToolWin, ImgList,
  Menus;

type
  TMainForm = class(TForm)
    PowerButton: TButton;
    GroupBox1: TGroupBox;
    editFrequency: TEdit;
    slFrequency: TTrackBar;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    listTone: TListBox;
    btnToneSelect: TButton;
    btnDoubleFreq: TButton;
    btnHalfFreq: TButton;
    panFreqAdjmt: TPanel;
    GroupBox2: TGroupBox;
    editLevel_0: TEdit;
    editLevel_1: TEdit;
    slLevel_0: TTrackBar;
    slLevel_1: TTrackBar;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    cbLevelLinked: TCheckBox;
    GroupBox3: TGroupBox;
    labelPhaseDif: TLabel;
    slPhaseDif: TTrackBar;
    labelPhaseDifValue: TLabel;
    labelPhaseOffset: TLabel;
    paintPhaseOffset: TPaintBox;
    Bevel1: TBevel;
    labelPhaseOffsetValue: TLabel;
    GroupBox4: TGroupBox;
    comboDevice: TComboBox;
    labelPCMFormat: TLabel;
    SetupButton: TButton;
    GroupBox5: TGroupBox;
    lvMacro: TListView;
    ToolBar1: TToolBar;
    btnAddMacro: TToolButton;
    btnDeleteMacro: TToolButton;
    ToolButton1: TToolButton;
    btnCopyMacro: TToolButton;
    ImageList1: TImageList;
    PopupMenu1: TPopupMenu;
    Add1: TMenuItem;
    Delete1: TMenuItem;
    N1: TMenuItem;
    Copy1: TMenuItem;
    groupTimer: TGroupBox;
    cbOnTimer: TCheckBox;
    dtpOnTime: TDateTimePicker;
    dtpOnDate: TDateTimePicker;
    cbOnDate: TCheckBox;
    cbOffTimer: TCheckBox;
    dtpOffTime: TDateTimePicker;
    Timer: TTimer;
    cbUptime: TCheckBox;
    labelUptime: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    procedure PowerButtonClick(Sender: TObject);
    procedure editFrequencyChange(Sender: TObject);
    procedure editFrequencyExit(Sender: TObject);
    procedure slFrequencyChange(Sender: TObject);
    procedure listToneSelect(Sender: TObject);
    procedure btnToneSelectClick(Sender: TObject);
    procedure btnDoubleFreqClick(Sender: TObject);
    procedure btnHalfFreqClick(Sender: TObject);
    procedure panFreqAdjmtMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure panFreqAdjmtMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure panFreqAdjmtMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure editLevelChange(Sender: TObject);
    procedure editLevel_0Exit(Sender: TObject);
    procedure editLevel_1Exit(Sender: TObject);
    procedure slLevelChange(Sender: TObject);
    procedure cbLevelLinkedClick(Sender: TObject);
    procedure slPhaseDifChange(Sender: TObject);
    procedure paintPhaseOffsetMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure paintPhaseOffsetMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure paintPhaseOffsetMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure paintPhaseOffsetPaint(Sender: TObject);
    procedure comboDeviceSelect(Sender: TObject);
    procedure SetupButtonClick(Sender: TObject);
    procedure AddMacroClick(Sender: TObject);
    procedure DeleteMacroClick(Sender: TObject);
    procedure CopyMacroClick(Sender: TObject);
    procedure lvMacroSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure lvMacroDeletion(Sender: TObject; Item: TListItem);
    procedure lvMacroColumnClick(Sender: TObject; Column: TListColumn);
    procedure TimerSettingChange(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure labelAddressClick(Sender: TObject);
  private
    TitleName: string;
    SG: TSineGen;
    LockCount: Integer;
    CurControl: TObject;
    PCMFormats: TPCMFormats;
    CanPower: Boolean;
    ValuesGot: TSGParamMask;
    DragPos: Integer;
    SortIndex: Integer;
    AdjFreqVal: Extended;
    OnTime: Cardinal;
    DevicePoll: Boolean;
    function slFrequencyAtPos(Pos: Integer): Real;
    function slPosOfFrequency(const Frequency: Real): Integer;
    procedure SetdBEdit(AEdit: TEdit; const AValue: Real);
    procedure GetValues(Sender: TSineGen; ParamMask: TSGParamMask);
    function TryEnterControl(AControl: TObject): Boolean;
    procedure ExitControl;
    procedure ControlLevel(const ALevel: Real; AControl: TObject);
    procedure AddMacro(const Frequency, Level_0, Level_1, PhaseDifference: Real);
    function OnRemainingTime: TDateTime;
    procedure UpdateTimerEnable;
    procedure WMSysColorChange(var Message: TMessage); message WM_SYSCOLORCHANGE;
  end;

var
  MainForm: TMainForm;

  DefPCMFormats: TPCMFormats;

implementation

uses
  Math, Types, GenUtils, SGFormSetup, Clipbrd, Registry, MMSystem, CommCtrl,
  Themes, ShellAPI;

{$R *.dfm}
{$R WindowsXP.res}

{ Tone conversion }

const
  ToneA4Index = 57;
  MaxToneIndex = 131;

function FrequencyOfTone(Tone: Integer): Real;
begin
  Result := RoundToLen(440 * Power(2, (Tone - ToneA4Index) / 12), 5);
end;

function ToneOfFrequency(const Frequency: Real; Exact: Boolean = False): Integer;
var
  Tone: Real;
begin
  Tone := ToneA4Index + 12 * Log2(Frequency / 440);
  Result := Round(Tone);
  if Exact and not IsZero(Tone - Result, 1.e-3) or not
    InRange(Result, 0, MaxToneIndex) then
    Result := -1;
end;

{ Slider logarithmic conversion }

const
  FreqLow = 15.0;
  FreqLogRange = 3.30103;

  FreqSliderPrec = 4;

function TMainForm.slFrequencyAtPos(Pos: Integer): Real;
begin
  Result := FreqLow * Power(10, Pos * FreqLogRange / slFrequency.Min);
end;

function TMainForm.slPosOfFrequency(const Frequency: Real): Integer;
begin
  if Frequency > 0 then
    Result := Round(Log10(Frequency / FreqLow) * slFrequency.Min / FreqLogRange)
  else
    Result := -1;
end;

{ Getting values }

resourcestring
  STitleFormat = '%.*f %sHz, %.1f dB - %s';
  SKilo = 'k';
  SUnknownMode = 'Unknown mode.';

procedure TMainForm.SetdBEdit(AEdit: TEdit; const AValue: Real);
const
  fmt: array[Boolean] of string = ('%g', '%.2f');
begin
  Inc(LockCount);                                          
  try
    AEdit.Text := Format(fmt[IsZero(Frac(AValue * 2))], [-AValue]);
  finally
    Dec(LockCount);
  end;
end;

procedure TMainForm.GetValues(Sender: TSineGen; ParamMask: TSGParamMask);

  procedure UpdateTitle;
  const
    KiloOpt: array[Boolean] of string = ('', SKilo);
  var
    Freq: Real;
    kHz: Boolean;
  begin
    if (SG <> nil) and SG.Active then
    begin
      Freq := SG.Frequency;
      kHz := Freq >= 1.e4;
      if kHz then
        Freq := Freq / 1.e3;
      Caption := Format(STitleFormat, [Max(FracLen(Freq, 4), 0), Freq,
        KiloOpt[kHz], SG.Level, TitleName]);
    end else
      Caption := TitleName;
    Application.Title := Caption;
  end;

  function RadToCycleStr(const AValue: Extended): string;
  const
    MinusOpt: array[Boolean] of string = ('', '-');
  var
    AbsCycles: Extended;
    AbsIntCycles: Integer;
    CyclesStr: string;
  begin
    AbsCycles := Abs(AValue / _2Pi);
    AbsIntCycles := Trunc(AbsCycles);
    if AbsIntCycles <> 0 then
      CyclesStr := Format('%dc.', [AbsIntCycles]);
    Result := Format('%s%s%.0f', [MinusOpt[AValue < -(Pi / 360)], CyclesStr,
      360 * Frac(AbsCycles)]);
  end;

var
  pcmf: TPCMFormat;
  i: Integer;
begin
  Inc(LockCount);
  try
    with Sender do
    begin
      if sgpActive in ParamMask then
      begin
        if Active then
          OnTime := GetTickCount;
        SetEnableControls([comboDevice, SetupButton], not Active);
        if not Stereo then
        begin
          if Active then
            cbLevelLinked.Checked := True;
          Include(ParamMask, sgpPhaseDifference);
        end;
        SetEnableControls([cbLevelLinked, labelPhaseDif, slPhaseDif,
          labelPhaseDifValue], Stereo or not Active);
        paintPhaseOffset.Repaint;
        if Active then
          Include(ParamMask, sgpPhaseOffset);
        labelPhaseOffset.Enabled := Active;
        labelPhaseOffsetValue.Caption := '';
        labelPhaseOffsetValue.Visible := Active;
        UpdateTitle;
        UpdateTimerEnable;
      end;
      if sgpFrequency in ParamMask then
      begin
        if editFrequency <> CurControl then
          if CurControl = slFrequency then
            editFrequency.Text := FloatToStrF(Frequency, ffFixed,
              FreqSliderPrec + 1, Max(FracLen(Frequency, FreqSliderPrec), 0))
          else
            editFrequency.Text := FloatToStr(Frequency);
        if slFrequency <> CurControl then
          slFrequency.Position := slPosOfFrequency(Frequency);
        if listTone <> CurControl then
          listTone.ItemIndex := ToneOfFrequency(Frequency, True);
        if Active then
          UpdateTitle;
      end;
      if sgpLevel in ParamMask then
      begin
        if Active then
          UpdateTitle;
      end;
      if sgpLevel_0 in ParamMask then
      begin
        if editLevel_0 <> CurControl then
          SetdBEdit(editLevel_0, Level_0);
        if slLevel_0 <> CurControl then
          slLevel_0.Position := Round(Level_0 * -2);
      end;
      if sgpLevel_1 in ParamMask then
      begin
        if editLevel_1 <> CurControl then
          SetdBEdit(editLevel_1, Level_1);
        if slLevel_1 <> CurControl then
          slLevel_1.Position := Round(Level_1 * -2);
      end;
      if sgpPhaseDifference in ParamMask then
      begin
        if Stereo or not Active then
          i := Round(RadToDeg(SG.PhaseDifference))
        else
          i := 0;
        if slPhaseDif <> CurControl then
          slPhaseDif.Position := i;
        labelPhaseDifValue.Caption := Format('%d', [i]);
      end;
      if sgpPhaseOffset in ParamMask then
      begin
        paintPhaseOffset.Repaint;
        labelPhaseOffsetValue.Caption := RadToCycleStr(SG.PhaseOffset);
      end;
      if sgpPCMFormat in ParamMask then
      begin
        labelPCMFormat.Caption := PCMFormatToStr(PCMFormat);
      end;
      if (sgpDevice in ParamMask) and not DevicePoll then
      begin
        if comboDevice <> CurControl then
          comboDevice.ItemIndex := DeviceID;
        CanPower := FindFirstSupportedOutPCMFormat(DeviceID, PCMFormats, pcmf);
        if CanPower then
          PCMFormat := pcmf
        else
          labelPCMFormat.Caption := SUnknownMode;
        PowerButton.Enabled := CanPower;
      end;
      if (ParamMask * [sgpFrequency, sgpLevel, sgpPhaseDifference] <> []) and
        (lvMacro <> CurControl) then
        lvMacro.Selected := nil;
      ValuesGot := ValuesGot + ParamMask;
    end;
  finally
    Dec(LockCount);
  end;
end;

procedure TMainForm.PowerButtonClick(Sender: TObject);
begin
  if SG <> nil then
    SG.Active := not SG.Active and CanPower;
end;

{ Parameter control }

function TMainForm.TryEnterControl(AControl: TObject): Boolean;
begin
  Result := (SG <> nil) and (LockCount = 0);
  if Result then
  begin
    Inc(LockCount);
    CurControl := AControl;
  end;
end;

procedure TMainForm.ExitControl;
begin
  CurControl := nil;
  Dec(LockCount);
end;

{ Frequency }

procedure TMainForm.editFrequencyChange(Sender: TObject);
begin
  if TryEnterControl(Sender) then
    try
      SG.Frequency := StrToFloatDef((Sender as TEdit).Text, SG.Frequency);
    finally
      ExitControl;
    end;
end;

procedure TMainForm.editFrequencyExit(Sender: TObject);
begin
  if SG <> nil then
  begin
    Inc(LockCount);
    try
      editFrequency.Text := FloatToStr(SG.Frequency);
    finally
      Dec(LockCount);
    end;
  end;
end;

procedure TMainForm.slFrequencyChange(Sender: TObject);
begin
  if TryEnterControl(Sender) then
    try
      SG.Frequency := RoundToLen(slFrequencyAtPos(slFrequency.Position),
        FreqSliderPrec);
    finally
      ExitControl;
    end;
end;

procedure TMainForm.listToneSelect(Sender: TObject);
var
  i: Integer;
begin
  i := listTone.ItemIndex;
  if (i <> -1) and TryEnterControl(Sender) then
    try
      SG.Frequency := FrequencyOfTone(i);
    finally
      ExitControl;
    end;
end;

procedure TMainForm.btnToneSelectClick(Sender: TObject);
begin
  if SG <> nil then
    SG.Frequency := FrequencyOfTone(ToneOfFrequency(SG.Frequency));
end;

procedure TMainForm.btnDoubleFreqClick(Sender: TObject);
begin
  if SG <> nil then
    SG.Frequency := 2 * SG.Frequency;
end;

procedure TMainForm.btnHalfFreqClick(Sender: TObject);
begin
  if SG <> nil then
    SG.Frequency := SG.Frequency / 2;
end;

procedure TMainForm.panFreqAdjmtMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  DragPos := Y;
  AdjFreqVal := Power(1e3, X / (Sender as TControl).ClientWidth);
end;

procedure TMainForm.panFreqAdjmtMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if (DragPos <> Low(Integer)) and (Y <> DragPos) then
  begin
    if SG <> nil then
      SG.Frequency := RoundToLen(SG.Frequency * Power(1.0135,
        -(Y - DragPos) / AdjFreqVal), 4 + Round(Log10(AdjFreqVal)));
    DragPos := Y;
  end;
end;

procedure TMainForm.panFreqAdjmtMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  DragPos := Low(Integer);
end;

{ Level }

procedure TMainForm.ControlLevel(const ALevel: Real; AControl: TObject);
begin
  if ALevel > 0 then
    Exit;
  if TryEnterControl(AControl) then
    try
      if cbLevelLinked.Checked then
        SG.Level := ALevel
      else
        case (AControl as TComponent).Tag of
          1: SG.Level_0 := ALevel;
          2: SG.Level_1 := ALevel;
        end;
    finally
      ExitControl;
    end;
end;

procedure TMainForm.slLevelChange(Sender: TObject);
begin
  ControlLevel((Sender as TTrackBar).Position / -2, Sender)
end;

procedure TMainForm.editLevelChange(Sender: TObject);
begin
  ControlLevel(-StrToFloatDef((Sender as TEdit).Text, -1), Sender);
end;

procedure TMainForm.editLevel_0Exit(Sender: TObject);
begin
  if SG <> nil then
    SetdBEdit(Sender as TEdit, SG.Level_0);
end;

procedure TMainForm.editLevel_1Exit(Sender: TObject);
begin
  if SG <> nil then
    SetdBEdit(Sender as TEdit, SG.Level_1);
end;

procedure TMainForm.cbLevelLinkedClick(Sender: TObject);
begin
  if cbLevelLinked.Checked and TryEnterControl(Sender) then
    try
      SG.Level := RoundTo(SG.Level, -2);
    finally
      ExitControl;
    end;
end;

{ Phase difference }

procedure TMainForm.slPhaseDifChange(Sender: TObject);
begin       
  if TryEnterControl(Sender) then
    try
      SG.PhaseDifference := DegToRad((Sender as TTrackBar).Position);
    finally
      ExitControl;
    end;
end;

{ Phase offset }

procedure TMainForm.paintPhaseOffsetMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  DragPos := X;
end;

procedure TMainForm.paintPhaseOffsetMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  if (DragPos <> Low(Integer)) and (X <> DragPos) then
  begin
    if SG <> nil then
      SG.PhaseOffset := SG.PhaseOffset - _2Pi * (X - DragPos) /
        paintPhaseOffset.Width;
    DragPos := X;
  end;
end;

procedure TMainForm.paintPhaseOffsetMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  DragPos := Low(Integer);
end;

procedure TMainForm.paintPhaseOffsetPaint(Sender: TObject);
var
  c: TPoint;
  x, y: Integer;
  kx, ky: Real;
begin
  with TPaintBox(Sender), Canvas do
  begin
    c := CenterPoint(ClientRect);
    if Height mod 2 = 0 then
      Dec(c.Y);
    kx := Pi / c.X;
    ky := c.Y;
    Pen.Color := clBtnShadow;
    MoveTo(c.X, 0);
    LineTo(c.X, Height);
    Pen.Color := Font.Color;
    if (SG <> nil) and SG.Active then
      for x := 0 to Width - 1 do
      begin
        y := Round(c.Y - Sin(SG.PhaseOffset + (x - c.X) * kx) * ky);
        if x = 0 then
          MoveTo(x, y)
        else
          LineTo(x, y);
      end;
  end;
end;

{ Output }

procedure TMainForm.comboDeviceSelect(Sender: TObject);
begin
  if TryEnterControl(Sender) then
    try
      SG.DeviceID := comboDevice.ItemIndex;
    finally
      ExitControl;
    end;
end;

procedure TMainForm.SetupButtonClick(Sender: TObject);
begin
  if SetupForm = nil then
    Application.CreateForm(TSetupForm, SetupForm);
  if (SG <> nil) and not SG.Active then
    with SetupForm do
    begin
      slLatency.Position := Round(SG.Latency * 1e3);
      slPrebuffer.Position := Round(SG.Prebuffer * 1e3);
      editFormats.Text := PCMFormatsToStr(PCMFormats);
      PlaceControl(SetupForm, CenterPoint(Self.BoundsRect));
      if (ShowModal = mrOk) and (SG <> nil) then
      begin
        SG.Latency := slLatency.Position * 1e-3;
        SG.Prebuffer := slPrebuffer.Position * 1e-3;
        PCMFormats := StrToPCMFormats(editFormats.Text);
        GetValues(SG, [sgpDevice]);
      end;
    end;
end;

{ Macros }

resourcestring
  SMacroAdding = 'SineGen macro adding';
  SMacroListTooLong = 'List too long! Delete something.';

type
  PMacroRec = ^TMacroRec;
  TMacroRec = record
  case Integer of
    0: (F, L_0, L_1, PD: Real);
    1: (Params: array[0..3] of Real);
  end;

procedure TMainForm.AddMacro(const Frequency, Level_0, Level_1,
  PhaseDifference: Real);
var
  Rec: PMacroRec;
begin
  New(Rec);
  with Rec^ do
  begin
    F := Frequency;
    L_0 := Level_0;
    L_1 := Level_1;
    PD := PhaseDifference;
  end;
  try
    with lvMacro.Items.Add do
    begin
      Caption := FloatToStrF(Frequency, ffGeneral, 7, 0);
      if Level_0 <> Level_1 then
        SubItems.Add(Format('%.1f / %.1f', [-Level_0, -Level_1]))
      else
        SubItems.Add(FloatToStrF(-Level_0, ffFixed, 7, 1));
      SubItems.Add(FloatToStrF(RadToDeg(PhaseDifference), ffFixed, 7, 1));
      Data := Rec;
    end;
  except
    Dispose(Rec);
    raise;
  end;
end;

procedure TMainForm.AddMacroClick(Sender: TObject);
begin
  if lvMacro.Items.Count >= 64 then
  begin
    MessageBox(Handle, PChar(SMacroListTooLong), PChar(SMacroAdding),
      MB_ICONEXCLAMATION);
    Exit;
  end;
  if SG <> nil then
    with SG do
      AddMacro(Frequency, Level_0, Level_1, PhaseDifference);
  SortIndex := -1;
end;

procedure TMainForm.DeleteMacroClick(Sender: TObject);
begin 
  lvMacro.DeleteSelected;
end;

procedure TMainForm.CopyMacroClick(Sender: TObject);
var
  Item: TListItem;
begin
  with TStringList.Create do
    try
      Item := nil;
      while True do
      begin
        Item := lvMacro.GetNextItem(Item, sdAll, [isSelected]);
        if Item = nil then
          Break;
        with PMacroRec(Item.Data)^ do
          Add(Format('%.11g'#9'%.2f'#9'%.2f'#9'%.1f', [F, L_0, L_1, PD]));
      end;
      Clipboard.AsText := Text;
    finally
      Free;
    end;
end;

procedure TMainForm.lvMacroSelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
var
  B: boolean;
begin
  if Selected and (lvMacro.SelCount = 1) then
    with SG, PMacroRec(Item.Data)^ do
      if TryEnterControl(Sender) then
        try
          Frequency := F;
          if Stereo or not Active then
          begin
            Level_0 := L_0;
            Level_1 := L_1;
          end
          else
            Level := RoundTo(MiddBLevel([L_0, L_1]), -2);
          PhaseDifference := PD;
        finally
          ExitControl;
        end;
  B := lvMacro.SelCount <> 0;
  btnDeleteMacro.Enabled := B;
  btnCopyMacro.Enabled := B;
  Copy1.Enabled := B;
  Delete1.Enabled := B;
end;

procedure TMainForm.lvMacroDeletion(Sender: TObject; Item: TListItem);
begin
  Dispose(PMacroRec(Item.Data));
end;

threadvar
  Descending: Boolean;

procedure TMainForm.lvMacroColumnClick(Sender: TObject; Column: TListColumn);

  function DoCompare(Item1, Item2: TListItem; ParamSort: Integer): Integer stdcall;
  var
    Rec1, Rec2: PMacroRec;
    V1, V2: Real;
  begin
    Rec1 := Item1.Data;
    Rec2 := Item2.Data;
    if ParamSort = 1 then
    begin
      V1 := MiddBLevel([Rec1.L_0, Rec1.L_1]);
      V2 := MiddBLevel([Rec2.L_0, Rec2.L_1]);
    end else
    begin
      if ParamSort = 2 then
        Inc(ParamSort);
      V1 := Rec1^.Params[ParamSort];
      V2 := Rec2^.Params[ParamSort];
    end;
    if SameValue(V1, V2) then
      Result := 0
    else
      if V1 > V2 then
        Result := 1
      else
        Result := -1;
    if Descending then
      Result := -Result;
  end;

begin
  Descending := Column.Index = SortIndex;
  lvMacro.CustomSort(@DoCompare, Column.Index);
  if Descending then
    SortIndex := -1
  else
    SortIndex := Column.Index;
end;

{ Timer }

resourcestring
  STimer = 'Timer';

function TMainForm.OnRemainingTime: TDateTime;
var
  OnTime, NowTime: TDateTime;
begin
  OnTime := Frac(dtpOnTime.Time);
  if cbOnDate.Checked then
  begin
    OnTime := OnTime + Int(dtpOnDate.Date);
    NowTime := Now;
  end else
    NowTime := Time;
  Result := OnTime - NowTime;
end;

procedure TMainForm.UpdateTimerEnable;
begin
  if SG <> nil then
    with SG do
      Timer.Enabled := Active and (cbUptime.Checked or cbOffTimer.Checked) or
        not Active and cbOnTimer.Checked and (OnRemainingTime > 0);
  if Timer.Enabled then
    TimerTimer(nil)
  else
    groupTimer.Caption := STimer;
end;

procedure TMainForm.TimerSettingChange(Sender: TObject);
begin
  UpdateTimerEnable;
  dtpOnDate.Enabled := cbOnDate.Checked;
  labelUptime.Visible := cbUptime.Checked;
end;

procedure TMainForm.TimerTimer(Sender: TObject);
const
  OneSecond = 1 / SecsPerDay;
var
  UpTime, RemainingTime: TDateTime;
begin
  if SG = nil then
    Exit;
  RemainingTime := -OneSecond;
  if SG.Active then
  begin
    UpTime := (GetTickCount - OnTime) / MSecsPerDay;
    if cbOffTimer.Checked then
    begin
      RemainingTime := Frac(dtpOffTime.Time) - UpTime;
      if RemainingTime <= 0 then
      begin
        SG.Active := False;
        Exit;
      end;
    end;
    if cbUptime.Checked then
      labelUptime.Caption := TimeToStrEx(UpTime);
  end
  else
    if cbOnTimer.Checked then
    begin
      RemainingTime := OnRemainingTime;
      if (RemainingTime <= 0) and (RemainingTime > -OneSecond) then
      begin
        SG.Active := CanPower;
        Exit;
      end;
    end;
  if RemainingTime >= 0 then
    groupTimer.Caption := Format('%s %s', [STimer, TimeToStrEx(RemainingTime)]);
end;

{ Initialization & saving }

const
  SFrequency        = 'Frequency';
  SLevel            = 'Level';
  SPhaseDifference  = 'PhaseDifference';
  SDevice           = 'Device';
  SLatency          = 'Latency';
  SPrebuffer        = 'Prebuffer';
  SFormats          = 'Formats';
  SMacroList        = 'MacroList';
  SSortIndex        = 'SortIndex';
  SShowUptime       = 'ShowUptime';

procedure TMainForm.FormCreate(Sender: TObject);
var
  f: Real;
  i, n, n1: Integer;
  Sharp: string;
  MacroRec: TMacroRec;
  dev_id: Integer;
  dev_name: string;
begin
  TitleName := Caption;
  Application.Title := TitleName;
  DragPos := Low(Integer);
  SortIndex := -1;

  ChangeWindowStyle(slFrequency.Handle, 0, TBS_ENABLESELRANGE);
  ChangeWindowStyle(slLevel_0.Handle, 0, TBS_ENABLESELRANGE);
  ChangeWindowStyle(slLevel_1.Handle, 0, TBS_ENABLESELRANGE);
  ChangeWindowStyle(slPhaseDif.Handle, 0, TBS_ENABLESELRANGE);

  f := 20;
  while f < 30000 do
  begin
    slFrequency.SetTick(slPosOfFrequency(f));
    f := f + IntPower(10, Trunc(Log10(f)));
  end;

  with listTone.Items do
  begin
    BeginUpdate;
    try
      Clear;
      for i := 0 to 10 do
        for n := 0 to 11 do
        begin
          n1 := n;
          if n > 4 then
            Inc(n1);
          if n1 and 1 <> 0 then
            Sharp := '#'
          else
            Sharp := '';
          Add(Format('%s%s%d', [Chr(Ord('A') + (2 + n1 shr 1) mod 7), Sharp, i]));
        end;
    finally
      EndUpdate;
    end;
  end;
  
  dtpOnDate.Date := Date;
  dtpOnTime.Time := Time;

  SG := TSineGen.Create;
  SG.OnParamsChange := GetValues;

  PCMFormats := DefPCMFormats;
  try
    with TRegistry.Create do
      try
        if OpenKey(RegKey, False) then
        begin
          with Screen.WorkAreaRect do
            SetBounds(
              EnsureRange(ReadInteger(SWindowLeft), Left, Max(Left, Right - Width)),
              EnsureRange(ReadInteger(SWindowTop), Top, Max(Top, Bottom - Height)),
              Width, Height);
          dev_name := ReadString(SDevice);
          with SG do
          begin
            Frequency := ReadFloat(SFrequency);
            Inc(LockCount);
            try
              cbLevelLinked.Checked := ValueExists(SLevel);
            finally
              Dec(LockCount);
            end;
            if cbLevelLinked.Checked then
              Level := ReadFloat(SLevel) else
            begin
              Level_0 := ReadFloat(SLevel + '0');
              Level_1 := ReadFloat(SLevel + '1');
            end;
            PhaseDifference := ReadFloat(SPhaseDifference);
            Latency := ReadInteger(SLatency) * 1e-3;
            Prebuffer := ReadInteger(SPrebuffer) * 1e-3;
          end;
          SetLength(PCMFormats, 16);
          SetLength(PCMFormats, ReadBinaryData(SFormats, Pointer(PCMFormats)^,
            Length(PCMFormats) * SizeOf(TPCMFormat)) div SizeOf(TPCMFormat));
          with TMemoryStream.Create do
            try
              Size := 2048;
              Size := ReadBinaryData(SMacroList, Memory^, Size);
              lvMacro.Items.BeginUpdate;
              try
                while (Read(MacroRec, SizeOf(TMacroRec)) = SizeOf(TMacroRec)) do
                  with MacroRec do
                    AddMacro(F, L_0, L_1, PD);
              finally
                lvMacro.Items.EndUpdate;
              end;
            finally
              Free;
            end;
          SortIndex := ReadInteger(SSortIndex);
          cbUptime.Checked := ReadBool(SShowUptime);
        end
        else
        begin
          PlaceControl(Self, CenterPoint(Screen.DesktopRect));
          AddMacro(440, -19, -19, Pi / 4);
          AddMacro(50, -3, -3, Pi);
          AddMacro(261.63, -15, -15, -Pi / 6);
          AddMacro(3000, -18, -18, 0);
        end;
      finally
        Free;
      end;
  except
    ApplicationHandleException(Self);
  end;

  dev_id := 0;
  DevicePoll := True;
  try
    for i := 0 to waveOutGetNumDevs - 1 do
    begin
      SG.DeviceID := i;
      comboDevice.Items.Add(SG.DeviceName);
      if AnsiCompareText(dev_name, SG.DeviceName) = 0 then
        dev_id := i;
    end;
  finally
    DevicePoll := False;
  end;
  SG.DeviceID := dev_id;
  
  GetValues(SG, [sgpFrequency, sgpLevel_0, sgpLevel_1, sgpPhaseDifference] -
    ValuesGot);
end;

procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
  I: Integer;
begin
  try
    with TRegistry.Create do
      try
        if OpenKey(RegKey, True) then
        begin
          WriteInteger(SWindowLeft, Left);
          WriteInteger(SWindowTop, Top);
          if SG <> nil then
            with SG do
            begin
              WriteString(SDevice, DeviceName);
              WriteFloat(SFrequency, Frequency);
              if cbLevelLinked.Checked then
              begin
                DeleteValue(SLevel + '0');
                DeleteValue(SLevel + '1');
                WriteFloat(SLevel, Level);
              end else
              begin
                DeleteValue(SLevel);
                WriteFloat(SLevel + '0', Level_0);
                WriteFloat(SLevel + '1', Level_1);
              end;
              WriteFloat(SPhaseDifference, PhaseDifference);
              WriteInteger(SLatency, Round(Latency * 1e3));
              WriteInteger(SPrebuffer, Round(Prebuffer * 1e3));
            end;
          WriteBinaryData(SFormats, Pointer(PCMFormats)^, Length(PCMFormats)
            * SizeOf(TPCMFormat));
          with TMemoryStream.Create do
            try
              with lvMacro do
                for I := 0 to Items.Count - 1 do
                  Write(PMacroRec(Items[I].Data)^, SizeOf(TMacroRec));
              WriteBinaryData(SMacroList, Memory^, Size);
            finally
              Free;
            end;
          WriteInteger(SSortIndex, SortIndex);
          WriteBool(SShowUptime, cbUptime.Checked);
        end;
      finally
        Free;
      end;
  except
    ApplicationHandleException(Self);
  end;
  FreeAndNil(SG);
end;

procedure TMainForm.WMSysColorChange(var Message: TMessage);
begin
  ThemeServices.UpdateThemes;
  inherited;
  SendMessage(slFrequency.Handle, TBM_CLEARSEL, 1, 0);
  SendMessage(slLevel_0.Handle, TBM_CLEARSEL, 1, 0);
  SendMessage(slLevel_1.Handle, TBM_CLEARSEL, 1, 0);
  SendMessage(slPhaseDif.Handle, TBM_CLEARSEL, 1, 0);
end;

procedure TMainForm.labelAddressClick(Sender: TObject);
var
  S: string;
begin
  S := (Sender as TLabel).Caption;
  if Pos('@', S) <> 0 then
    S := Format('mailto:%s?subject=%s', [S, ProductName]);
  ShellExecute(Handle, nil, PChar(S), nil, nil, SW_SHOWNORMAL);
end;

initialization
  ProductName := 'SineGen';
  CompanyName := 'eCat';

  SetLength(DefPCMFormats, 4);

  DefPCMFormats[0].BitDepth := 24;
  DefPCMFormats[0].SamplingRate := 96000;
  DefPCMFormats[0].ChannelCount := 2;

  DefPCMFormats[1].BitDepth := 16;
  DefPCMFormats[1].SamplingRate := 48000;
  DefPCMFormats[1].ChannelCount := 2;

  DefPCMFormats[2].BitDepth := 16;
  DefPCMFormats[2].SamplingRate := 44100;
  DefPCMFormats[2].ChannelCount := 2;

  DefPCMFormats[3].BitDepth := 16;
  DefPCMFormats[3].SamplingRate := 48000;
  DefPCMFormats[3].ChannelCount := 1;

end.
