unit SGFormSetup;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls;

type
  TSetupForm = class(TForm)
    GroupBox1: TGroupBox;
    labelLatency: TLabel;
    slLatency: TTrackBar;
    labelLatencyValue: TLabel;
    labelPrebuffer: TLabel;
    slPrebuffer: TTrackBar;
    labelPrebufferValue: TLabel;
    labelFormats: TLabel;
    editFormats: TEdit;
    btnReset: TButton;
    btnOK: TButton;
    btnCancel: TButton;
    procedure FormCreate(Sender: TObject);
    procedure slLatencyChange(Sender: TObject);
    procedure slPrebufferChange(Sender: TObject);
    procedure btnResetClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  SetupForm: TSetupForm;

implementation

uses SGForm, WaveFmt, GenUtils, CommCtrl;

{$R *.dfm}

resourcestring
  STime = '%d ms';

procedure TSetupForm.FormCreate(Sender: TObject);
begin
  ChangeWindowStyle(slLatency.Handle, 0, TBS_ENABLESELRANGE);
  ChangeWindowStyle(slPrebuffer.Handle, 0, TBS_ENABLESELRANGE);
  slLatencyChange(nil);
  slPrebufferChange(nil);
end;

procedure TSetupForm.slLatencyChange(Sender: TObject);
begin
  labelLatencyValue.Caption := Format(STime, [slLatency.Position]);
end;

procedure TSetupForm.slPrebufferChange(Sender: TObject);
begin
  labelPrebufferValue.Caption := Format(STime, [slPrebuffer.Position]);
end;

procedure TSetupForm.btnResetClick(Sender: TObject);
begin
  slLatency.Position := 50;
  slPrebuffer.Position := 100;
  editFormats.Text := PCMFormatsToStr(DefPCMFormats);
end;

end.
